// CaptureTestDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "CaptureTest.h"
#include "CaptureTestDlg.h"
#include "MD5.h"
#include <string>
#include <sstream>
#include <iostream> 
#include <fstream> 
using namespace std;
#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#pragma warning(disable:4482)
// Ӧó򡰹ڡ˵ CAboutDlg Ի

wstring GetCurrentPath()
{
	WCHAR wcsPath[MAX_PATH] = {0};
	GetModuleFileNameW(NULL, wcsPath, MAX_PATH);
	wstring strPath = wcsPath;
	int nPos = strPath.rfind(L'\\');
	strPath = strPath.substr(0, nPos + 1);
	return strPath;
}

string GetCurrentPathA()
{
	char szPath[MAX_PATH] = {0};
	GetModuleFileName(NULL, szPath, MAX_PATH);
	string strPath = szPath;
	int nPos = strPath.rfind(L'\\');
	strPath = strPath.substr(0, nPos + 1);
	return strPath;
}


std::wstring Ansi2WChar(LPCSTR pszSrc, int nLen)
{
	int nSize = MultiByteToWideChar(CP_ACP, 0, (LPCSTR)pszSrc, nLen, 0, 0);
	if(nSize <= 0) return L"";

	WCHAR *pwszDst = new WCHAR[nSize+1];
	if( NULL == pwszDst) return L"";

	MultiByteToWideChar(CP_ACP, 0,(LPCSTR)pszSrc, nLen, pwszDst, nSize);
	pwszDst[nSize] = 0;

	if( pwszDst[0] == 0xFEFF)                    // skip Oxfeff
		for(int i = 0; i < nSize; i ++) 
			pwszDst[i] = pwszDst[i+1]; 

	wstring wcharString(pwszDst);
	delete[] pwszDst;

	return wcharString;
}


std::wstring s2ws(const string& s)
{
	return Ansi2WChar(s.c_str(),s.size());
}

string GenerateAuthCode(string strAuthCode)
{
	SYSTEMTIME m_time;
	GetLocalTime(&m_time);
	int year=m_time.wYear;
	int month=m_time.wMonth;
	int day=m_time.wDay;
	ostringstream oss;
	oss << year << month << day;

	string strpwd = strAuthCode;
	strpwd += oss.str();
	return MD5Encode((char*)strpwd.c_str());
}
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Ի
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ֧

// ʵ
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CCaptureTestDlg Ի
//typedef int (__stdcall *FnInitScreenCaptureW)  (const char* szAuth);

typedef int (__stdcall *FnStartScreenCaptureW)(const wchar_t* szDefaultSavePath, void* pCallBack, UINT_PTR hWndNotice, UINT_PTR noticeMsg, UINT_PTR hwndHideWhenCapture, int autoCapture, int x, int y, int width, int height);
FnStartScreenCaptureW gl_StartScreenCapture = NULL;
typedef int (__stdcall *FnInitScreenCaptureW)(const wchar_t* szAuth);
FnInitScreenCaptureW gl_InitCapture = NULL;

typedef int (__stdcall *FnInitCaptureParamW)(int flag, UINT_PTR flagvalue);
FnInitCaptureParamW gl_InitCaptureParam = NULL;



typedef enum ExtendFlagTypeEnum
{
	emPensize = 1,		//ûʴС
	emDrawType,			//Ѷ360
	emTrackColor,		//Զʶı߿ɫ
	emEditBorderColor,	//ıı߿ɫ
	emTransparent,		//͸
	emWindowAware,		//ǷDPIŴ
	emDetectSubWindowRect,	//ǷԶӴڣʱ 
	emSetSaveName,		//ñʱĿʼ
	emSetMagnifierBkColor, //÷Ŵ󾵵ıɫ͸
	emSetMagnifierLogoText, //÷ŴϵLOGOַʾݼ磺 ţţͼ(CTRL + SHIFT + A)
	emSetNoticeCallback = 19,				//ÿؼ֪ͨϢĻص 
	emSetWatermarkPictureType,						//ˮӡ 
	emSetWatermarkPicturePath,						//ˮӡ· 
	emSetWatermarkTextType,						//ˮӡֵ 
	emSetWatermarkTextValue,						//ˮӡ
	emSetMosaicType,							//ͣ1ΪΣ2Ϊ 
	emSetToolbarText,							//ùϵĸťtooltipʾ  

};

CCaptureTestDlg::CCaptureTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCaptureTestDlg::IDD, pParent)
{
	//ؽͼؼ
	string strDllPath = GetCurrentPathA() + "NiuniuCapture.dll";
#ifdef __X64
	strDllPath = GetCurrentPathA() + "NiuniuCapturex64.dll";
#endif
	m_hModule = LoadLibrary(strDllPath.c_str());
	DWORD dRet = GetLastError();
	gl_StartScreenCapture = (FnStartScreenCaptureW)GetProcAddress(m_hModule, "StartScreenCaptureW");
	gl_InitCapture = (FnInitScreenCaptureW)GetProcAddress(m_hModule, "InitScreenCaptureW");
	gl_InitCaptureParam = (FnInitCaptureParamW)GetProcAddress(m_hModule, "InitCaptureParamW");

	//˴ֱӴ niuniu ΪȨ
	//Ȩ汾ȨΪKey, Եǰڽβַmd5ַ 
	string authCode = "niuniu";
	authCode = GenerateAuthCode(authCode);
	
	wstring wcsCode = s2ws(authCode);
	//˺Ҫú  
	gl_InitCapture(wcsCode.c_str());
	//gl_InitCapture(authCode.c_str());
	
	gl_InitCaptureParam(ExtendFlagTypeEnum::emPensize, 2);	//߿
	gl_InitCaptureParam(ExtendFlagTypeEnum::emDrawType, 0);	//÷Ŵ󾵷0 Ѷ   1 360 
	gl_InitCaptureParam(ExtendFlagTypeEnum::emTrackColor, RGB(255, 0, 0));	//Զʶı߿ɫ
	gl_InitCaptureParam(ExtendFlagTypeEnum::emEditBorderColor, RGB(0, 174, 255));	//ֱ༭߿ɫ
	gl_InitCaptureParam(ExtendFlagTypeEnum::emTransparent, 240); //ù͸


/***********************************************ⲿΪˮӡͼƬˮӡ֣Ҫȥ **************************/	
	//nShowType|nMinWidth|nMinHeight|nMaxWidth|nMaxHeight|nShowOffset
	const wchar_t* szWatermarkFlag = L"3|100|100|400|400|20";
	gl_InitCaptureParam(ExtendFlagTypeEnum::emSetWatermarkPictureType, (UINT_PTR)szWatermarkFlag);
	
	//ˮӡͼƬ·  
	wstring strWaterPath = GetCurrentPath() + L"watermark.png";
	//gl_InitCaptureParam(ExtendFlagTypeEnum::emSetWatermarkPicturePath, (UINT_PTR)strWaterPath.c_str());

	
	//nShowType|nMinWidth|nMinHeight|nVerticalInterval|nOffset|nFontSize|nIsBold|nTextWidth|nTextHeight|colorText
	//colorTextֵΪ A,R,G,B
	wstring strWaterTextFlag = L"3|60|60|150|20|20|0|200|50|80,55,55,55";
	gl_InitCaptureParam(ExtendFlagTypeEnum::emSetWatermarkTextType, (UINT_PTR)strWaterTextFlag.c_str());

	wstring strWaterText = L"ˮӡ޸ġ 2015-07-25 23:00:00";
//	gl_InitCaptureParam(ExtendFlagTypeEnum::emSetWatermarkTextValue, (UINT_PTR)strWaterText.c_str());
/***********************************************ϲΪˮӡͼƬˮӡ֣Ҫȥ **************************/


	wstring strSavePath = L"ţţͼ";
	gl_InitCaptureParam(ExtendFlagTypeEnum::emSetSaveName, (UINT_PTR)strSavePath.c_str()); //ñʱĿʼ
	gl_InitCaptureParam(ExtendFlagTypeEnum::emSetMagnifierBkColor, RGB(255, 255, 255)); //÷Ŵ󾵵ıɫ͸
	
	//¿÷ŴϵLOGO֣ãĬʾţţͼ 
	//gl_InitCaptureParam(ExtendFlagTypeEnum::emSetMagnifierLogoText, (UINT_PTR)"ţţͼ(Ctrl+Shift+A)");
	wstring strMagnifierLogoText = L"  ͨӿ";
	gl_InitCaptureParam(ExtendFlagTypeEnum::emSetMagnifierLogoText, (UINT_PTR)strMagnifierLogoText.c_str());
	
	//ùϵĸťtooltipԼɰťʾϢ 
	//tipRectangle|tipCircle|tipArrow|tipBrush|tipGlitter|tipMosaic|tipText|tipUndo|tipSave|tipCancel|tipFinish|txtFinish
	wstring strToolbarText = L"Rectangle|Circle|Arrow|Brush|Glitter|Mosaic|Text|Undo|Save|Cancel|Finish|Finish";
	gl_InitCaptureParam(ExtendFlagTypeEnum::emSetToolbarText, (UINT_PTR)strToolbarText.c_str());
	gl_InitCaptureParam(ExtendFlagTypeEnum::emWindowAware, 1); //˺贰ڴǰãͬ´

	//ͨδúӦó򽫲DPIзŴDPIŴĻϣҪôAPI һҪڴڴǰеãӦóʼʼĵط 
	/*
	HINSTANCE hUser32 = LoadLibrary( "user32.dll" );
	if( hUser32 )
	{
		typedef BOOL ( WINAPI* LPSetProcessDPIAware )( void );
		LPSetProcessDPIAware pSetProcessDPIAware = ( LPSetProcessDPIAware )GetProcAddress(hUser32,
			"SetProcessDPIAware" );
		if( pSetProcessDPIAware )
		{
			pSetProcessDPIAware();
		}
		FreeLibrary( hUser32 );
	}
	*/

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);	
}

void CCaptureTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CCaptureTestDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_MESSAGE(WM_USER + 1111,OnCaptureFinish)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &CCaptureTestDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDC_RADIO1, &CCaptureTestDlg::OnBnClickedRadio1)
	ON_BN_CLICKED(IDC_RADIO2, &CCaptureTestDlg::OnBnClickedRadio2)
END_MESSAGE_MAP()



// CCaptureTestDlg Ϣ

BOOL CCaptureTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ...˵ӵϵͳ˵С

	// IDM_ABOUTBOX ϵͳΧڡ
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ô˶ԻͼꡣӦóڲǶԻʱܽԶ
	//  ִд˲
	SetIcon(m_hIcon, TRUE);			// ôͼ
	SetIcon(m_hIcon, FALSE);		// Сͼ

	CenterWindow();
	ShowWindow(SW_SHOW);

	CButton* btn = (CButton*)GetDlgItem(IDC_RADIO1);
	btn->SetCheck(TRUE);
	
	

	SetWindowText("ţţͼ");
	return TRUE;  // ǽõؼ򷵻 TRUE
}

void CCaptureTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// ԻСťҪĴ
//  Ƹͼꡣʹĵ/ͼģ͵ MFC Ӧó
//  ⽫ɿԶɡ

void CCaptureTestDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ڻƵ豸

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// ʹͼڹо
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ͼ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//û϶Сʱϵͳô˺ȡùʾ
//
HCURSOR CCaptureTestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

HWND gl_hWnd = NULL;
//szInfoΪUTF8ַڱͼʱر·   
void CaptureNotice(int nType, int x, int y, int width, int height, const char* szInfo)
{
	if (nType == 1)	//ʾͼ 
	{
	}
	else if(nType == 2)	//ʾȡͼ
	{

	}
	else		//ͼ 
	{

	}
	::PostMessage(gl_hWnd, WM_USER + 1111, 1, nType);
}

void CCaptureTestDlg::OnBnClickedOk()
{
	SetDlgItemText(IDC_STATIC_NOTICE, "");
// 
// 	string strPath = _TEXT("c:\\һ\\test.jpg");
// 	locale loc = locale::global(locale(""));
// 	ifstream  fin(strPath.c_str(), ios::binary);  
// 	locale::global(loc);
// 	fin.exceptions ( ifstream::eofbit | ifstream::failbit | ifstream::badbit );  
// 
// 	istream::pos_type current_pos = fin.tellg();//¼µǰλ   
// 	fin.seekg(0,ios_base::end);//ƶļβ  
// 	istream::pos_type file_size = fin.tellg();//ȡõǰλõָ볤->ļ   
// 	fin.seekg(current_pos);//ƶԭλ  
// 	return;
	/*
	1Ķ 
	typedef enum ExtendFlagTypeEnum
	{
	emPensize = 1,
	emDrawType,	
	};
	*/
	CButton* btn = (CButton*)GetDlgItem(IDC_RADIO2);
	BOOL bCheck = btn->GetCheck();
	
	btn = (CButton*)GetDlgItem(IDC_CHECK_WATERTEXT);
	BOOL bShowWaterText = btn->GetCheck();
	
	if (bShowWaterText)
	{
		wstring strText = L"רˮӡ֣ؾ!";
		gl_InitCaptureParam(ExtendFlagTypeEnum::emSetWatermarkTextValue, (UINT_PTR)strText.c_str());
	}
	else
	{
		gl_InitCaptureParam(ExtendFlagTypeEnum::emSetWatermarkTextValue, (UINT_PTR)"");
	}
	gl_InitCaptureParam(2, bCheck);	//2壬0 Ѷ   1 360 
	//gl_InitCaptureParam(24, bCheck ? 1 : 2);
	//ͨص֪ͨͼ¼
	gl_hWnd = m_hWnd;
	const wchar_t* szSavePath = L"c:\\һ\\test.jpg";
	gl_StartScreenCapture(szSavePath, CaptureNotice, 0, 0, 
		0,
		0, 0, 0, 0, 0);

	//ͨ WINDOWS Ϣ֪ͨͼ¼

	//gl_StartScreenCapture("niuniu", "", NULL, (UINT_PTR)m_hWnd, WM_USER + 1111);
}


LRESULT CCaptureTestDlg::OnCaptureFinish(WPARAM wParam,LPARAM lParam)
{
	if (wParam == 1)
	{
		switch(lParam)
		{
		case 1:
			SetDlgItemText(IDC_STATIC_NOTICE, "ͼ");
			break;
		case 2:
			SetDlgItemText(IDC_STATIC_NOTICE, "ȡ˽ͼ");
			break;
		case 3:
			SetDlgItemText(IDC_STATIC_NOTICE, "˽ͼ");
			break;
		}
	}	
	return 0;
}

void CCaptureTestDlg::OnBnClickedRadio1()
{
	CButton* btn = (CButton*)GetDlgItem(IDC_RADIO1);
	btn->SetCheck(TRUE);

	btn = (CButton*)GetDlgItem(IDC_RADIO2);
	btn->SetCheck(FALSE);
}

void CCaptureTestDlg::OnBnClickedRadio2()
{
	CButton* btn = (CButton*)GetDlgItem(IDC_RADIO1);
	btn->SetCheck(FALSE);

	btn = (CButton*)GetDlgItem(IDC_RADIO2);
	btn->SetCheck(TRUE);
}
